/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.mode;

import java.util.Map;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class MEM extends AddressingMode
{
    public static final String NAME = "MEM";

    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               MEM.class,
               "MEM",
               new ParamDecls()
                   .declareParam("i", INDEX)
            );
        }

        @Override
        public IAddressingMode create(Map<String, Data> args)
        {
            final Location i = getArgument("i", args);
            return new MEM(i);
        }
    }

    public static final IInfo INFO = new Info();

    private final Location i;

    public MEM(Location i)
    {
        this.i = i;
    }

    @Override
    public String syntax()
    {
        return String.format("(%d)", i.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%6b", i.load().getRawData().toBinString());
    }

    @Override
    public Location access()
    {
        return M.access(DataEngine.intValue(i.load()));
    }
}
 