/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVN extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               MOVN.class,
               "MOVN",
               false,
               new ParamDecls()
                   .declareParam("rd", R.INFO)
                   .declareParam("rs", R.INFO)
                   .declareParam("rt", R.INFO));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

            return new MOVN(rd, rs, rt);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rd;
    private final IAddressingMode rs;
    private final IAddressingMode rt;

    public MOVN(IAddressingMode rd, IAddressingMode rs, IAddressingMode rt)
    {
        assert R.INFO.isSupported(rd);
        assert R.INFO.isSupported(rs);
        assert R.INFO.isSupported(rt);

        this.rd = rd;
        this.rs = rs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("MOVN %s, %s, %s", rd.syntax(), rs.syntax(), rt.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%s%s%s00000001011", rs.image(), rt.image(), rd.image());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(rt.access().load()) != 0)
        {
            rd.access().store(rs.access().load());
        }
    }
}
