/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IOperation;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class vliw extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               vliw.class,
               "vliw",
               true,
               new ParamDecls()
                   .declareParam("c1", channel1.INFO)
                   .declareParam("c2", channel2.INFO));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IOperation c1 = (IOperation) getArgument("c1", args);
            final IOperation c2 = (IOperation) getArgument("c2", args);

            return new vliw(c1, c2);
        }
    }

    public static final IInfo INFO = new Info();

    private final IOperation c1;
    private final IOperation c2;

    public vliw(IOperation c1, IOperation c2)
    {
        assert channel1.INFO.isSupported(c1);
        assert channel2.INFO.isSupported(c2);

        this.c1 = c1;
        this.c2 = c2;
    }

    @Override
    public String syntax()
    {
        return String.format("%s; %s;", c1.syntax(), c2.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s%s", c1.image(), c2.image());
    }

    @Override
    public void action()
    {
        NIA.access().store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 2 * INSTRUCTION_WORD_SIZE)));
        GPR.access(0).store(DataEngine.valueOf(Type.INT(1), 0));
        c1.action();
        GPR.access(0).store(DataEngine.valueOf(Type.INT(1), 0));
        c2.action();
        if (DataEngine.intValue(BRANCH.access().load()) == 0)
        {
            CIA.access().store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 2 * INSTRUCTION_WORD_SIZE)));
        }
        else
        {
            CIA.access().store(JMPADDR.access().load());
            __CTRL_TRANSFER.set(1);
        }
    }
}
